#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=galgenraten.ico
#AutoIt3Wrapper_outfile=galgenraten.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Galgenraten
#AutoIt3Wrapper_Res_Fileversion=2.1.0.0
#AutoIt3Wrapper_Res_LegalCopyright=(c) 2011 by Oscar
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_AU3Check_Stop_OnWarning=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <EditConstants.au3>
#include <File.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <Misc.au3>
#include <StaticConstants.au3>
#include <String.au3>
#include <WindowsConstants.au3>

Opt('TrayAutoPause', 0)
Opt('GUIOnEventMode', 1)

Global $title = 'Galgenraten v2.1   ' & Chr(169) & ' 2011 by Oscar'

#Region Check
If (@AutoItVersion < '3.2.10.0') and (Not @Compiled) Then Exit MsgBox(48, $title, 'Dieses Script bentigt Version: 3.2.10.0 ' & @CRLF & @CRLF & 'Gestartet wurde es mit Version: ' & @AutoItVersion)

If _Singleton($title, 1) = 0 Then Exit MsgBox(48, $title, 'Das Programm luft bereits!')

Global $aPic[13] = ['galgen00','galgen01','galgen02','galgen03','galgen04','galgen05','galgen06','galgen07','galgen08','galgen09','start','stop','titel']
For $x = 0 To UBound($aPic)-1
	$aPic[$x] = @ScriptDir & '\gfx\' & $aPic[$x] & '.jpg'
	If Not FileExists($aPic[$x]) Then
		MsgBox(16, $title, 'Die Grafik-Datei: "' & $aPic[$x] & '"  fehlt!')
		Exit
	EndIF
Next

Global $aSnd[8] = ['done','double','enforce','hiscore','no','ok','start','stop']
For $x = 0 To UBound($aSnd)-1
	$aSnd[$x] = @ScriptDir & '\snd\' & $aSnd[$x] & '.mp3'
	If Not FileExists($aSnd[$x]) Then
		MsgBox(16, $title, 'Die MP3-Datei: "' & $aSnd[$x] & '"  fehlt!')
		Exit
	EndIF
Next
#EndRegion Check

Global $sFile, $aWords, $aTempWords
$sFile = FileRead(@ScriptDir & '\woerter.txt')
If @error Then Exit MsgBox(4096, 'Error', 'Die Wrter-Datei konnte nicht geladen werden!')
$aWords = StringSplit(StringTrimRight($sFile, 2), @CRLF, 3)
$aTempWords = $aWords

Global $aRanking = IniReadSection(@ScriptDir & '\galgenraten.ini', 'ranking')
If @error Then
	Global $aRanking[16][2]
	$aRanking[0][0] = 15
	For $i = 1 To 15
		$aRanking[$i][0] = 'Computer'
		$aRanking[$i][1] = 16-$i
	Next
	IniWriteSection(@ScriptDir & '\galgenraten.ini', 'ranking', $aRanking)
EndIf

Global $Randomword, $Emptyword, $Error = 0, $tWords, $Score = 0, $haRanking[16], $bNeu = True, $bSound = True
Global $Caption = 0xffff66, $Backgr = 0x333333

Global $GUI = GUICreate($title, 795, 600, -1, -1)
GUISetOnEvent($GUI_EVENT_CLOSE, 'End')
GUISetBKColor($Backgr)
GUICtrlCreatePic(@ScriptDir & '\gfx\titel.jpg', 170, 5, 380, 60)
Global $hGalgen = GUICtrlCreatePic(@ScriptDir & '\gfx\galgen00.jpg', 190, 80, 320, 320)
Global $hStart = GUICtrlCreatePic(@ScriptDir & '\gfx\start.jpg', 55, 330, 90, 90)
GUICtrlSetOnEvent(-1, 'Start')
Global $t = ' /   =  ae / Ae' & @CRLF & @CRLF & ' /   =  ue / Ue' & @CRLF & @CRLF & ' /   =  oe / Oe' & @CRLF & @CRLF & '        =  ss'
GUICtrlCreateGroup('', 10, 185, 160, 140)
	GUICtrlCreateLabel(' Bitte beachten:', 18, 183, 93, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	GUICtrlCreateLabel($t, 30, 210, 130, 110)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, 0xdddddd)
GUICtrlCreateGroup('', -99, -99, 1, 1)
GUICtrlCreateGroup('', 10, 75, 160, 45)
	GUICtrlCreateLabel(' Gesamtpunktzahl', 20, 73, 103, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	Global $hScore = GUICtrlCreateLabel('0', 20, 92, 140, 20, $SS_RIGHT)
	GUICtrlSetFont(-1, 16, 800, 0, 'Courier New')
	GUICtrlSetColor(-1, 0xffffff)
GUICtrlCreateGroup('', -99, -99, 1, 1)
GUICtrlCreateGroup('', 10, 125, 160, 45)
	GUICtrlCreateLabel(' Geratene Wrter', 20, 123, 103, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	Global $hWords = GUICtrlCreateLabel('0', 20, 142, 140, 20, $SS_RIGHT)
	GUICtrlSetFont(-1, 16, 800, 0, 'Courier New')
	GUICtrlSetColor(-1, 0xffffff)
GUICtrlCreateGroup('', -99, -99, 1, 1)
Global $hSc = GUICtrlCreateLabel('9', 195, 86, 20, 20, $SS_CENTER)
GUICtrlSetFont(-1, 14, 800, 0, 'Courier New')
GUICtrlSetColor(-1, 0xffffff)
GUICtrlSetBKColor(-1, 0x000000)
GUICtrlCreateGroup('', 530, 75, 255, 320)
	GUICtrlCreateLabel(' Bestenliste', 550, 73, 70, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	Global $hRanking = GUICtrlCreateListview('||', 540, 97, 235, 290)
	GUICtrlSetFont(-1, 11, 400, 0, 'Times New Roman')
	GUICtrlSetColor(-1, 0xffffff)
	GUICtrlSetBKColor(-1, $Backgr)
	_GUICtrlListView_SetColumn(GUICtrlGetHandle($hRanking), 0, 'Name', 118)
	_GUICtrlListView_SetColumn(GUICtrlGetHandle($hRanking), 1, 'Punkte', 88, 1)
	For $i = 1 To 15
		$haRanking[$i] = GUICtrlCreateListViewItem('|', $hRanking)
	Next
	RankingDisplay()
GUICtrlCreateGroup('', -99, -99, 1, 1)
GUICtrlCreateGroup('', 10, 425, 70, 56)
	GUICtrlCreateLabel(' Eingabe', 18, 423, 50, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	Global $hInp = GUICtrlCreateInput('', 20, 442, 50, 36, $ES_LOWERCASE, $WS_EX_WINDOWEDGE)
	GUICtrlSetFont(-1, 20, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, 0xffff00)
	GUICtrlSetBKColor(-1, $Backgr)
	GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlCreateGroup('', -99, -99, 1, 1)
GUICtrlCreateGroup('', 110, 426, 480, 56)
	GUICtrlCreateLabel(' Geratene Buchstaben', 118, 423, 125, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	Global $hSel = GUICtrlCreateLabel('', 130, 444, 440, 36)
	GUICtrlSetFont(-1, 14, 800, 0, 'Courier New')
	GUICtrlSetColor(-1, 0xffffff)
GUICtrlCreateGroup('', -99, -99, 1, 1)
GUICtrlCreateGroup('', 615, 426, 170, 56)
	GUICtrlCreateLabel(' Sound', 625, 424, 42, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	Global $hSound = GUICtrlCreateCheckbox('', 630, 450, 16, 16)
	GUICtrlSetState(-1, $GUI_CHECKED)
	GUICtrlSetOnEvent(-1, 'Sound')
	GUICtrlCreateLabel('Gerusche an / aus', 650, 450, 110, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1,0xdddddd)
GUICtrlCreateGroup('', -99, -99, 1, 1)
GUICtrlCreateGroup('', 10, 522, 775, 65)
	GUICtrlCreateLabel(' Das zu ratende Wort (zufllig ausgewhlt aus ' & UBound($aWords) - 1 & ' Wrter)', 18, 520, 340, 16)
	GUICtrlSetFont(-1, 10, 800, 0, 'Times New Roman')
	GUICtrlSetColor(-1, $Caption)
	Global $hText = GUICtrlCreateLabel('', 25, 545, 745, 35)
	GUICtrlSetFont(-1, 16, 800, 0, 'Courier New')
	GUICtrlSetColor(-1, 0xffffff)
GUICtrlCreateGroup('', -99, -99, 1, 1)
GUISetState()

While 1
	Sleep(100)
	If $Error < 9 Then Check()
WEnd

Func End()
	IniWriteSection(@ScriptDir & '\galgenraten.ini', 'ranking', $aRanking)
	Exit
EndFunc

Func Sound()
	$bSound = BitAnd(GUICtrlRead($hSound), $GUI_CHECKED)
EndFunc

Func RankingDisplay()
	For $i = 1 To 15
		GUICtrlSetData($haRanking[$i], $aRanking[$i][0] & '|' & $aRanking[$i][1])
	Next
EndFunc

Func PlaySound($sound, $par)
	If $bSound Then SoundPlay(@ScriptDir & '\snd\' & $sound, $par)
EndFunc

Func Start()
	Local $iRandom
	If $bNeu Then
		$Score = 0
		GUICtrlSetData($hScore, $Score)
		GUICtrlSetData($hWords, 0)
		GUICtrlSetData($hText, '')
		GUICtrlSetState($hStart, $GUI_HIDE)
		GUICtrlSetData($hSel, '')
		GUICtrlSetImage($hGalgen, @ScriptDir & '\gfx\galgen00.jpg')
		PlaySound('start.mp3', 1)
	EndIf
	$bNeu = True
	GUICtrlSetImage($hStart, @ScriptDir & '\gfx\stop.jpg')
	GUICtrlSetState($hStart, $GUI_SHOW)
	GUICtrlSetOnEvent($hStart, 'Stop')
	$iRandom = Random(0, UBound($aTempWords) - 1, 1)
	$Randomword = $aTempWords[$iRandom]
	$aTempWords[$iRandom] = $aTempWords[UBound($aTempWords) - 1]
	If UBound($aTempWords) = 1 Then
		$aTempWords = $aWords
	Else
		ReDim $aTempWords[UBound($aTempWords) - 1]
	EndIf
	$Emptyword = _StringRepeat('_ ', StringLen($Randomword))
	GUICtrlSetData($hText, $Emptyword)
	GUICtrlSetState($hInp, $GUI_SHOW)
	GUICtrlSetState($hInp, $GUI_FOCUS)
	$Error = 0
	GUICtrlSetData($hSc, 9 - $Error)
	GUICtrlSetImage($hGalgen, @ScriptDir & '\gfx\galgen' & StringRight('0' & $Error, 2) & '.jpg')
	$tWords = ''
	GUICtrlSetData($hSel, $tWords)
EndFunc

Func Stop()
	PlaySound('stop.mp3', 0)
	If MsgBox(4, 'Galgenraten', 'Wirklich aufgeben?') = 6 Then
		$error = 8
		Galgen()
		GUICtrlSetImage($hStart, @ScriptDir & '\gfx\start.jpg')
		GUICtrlSetOnEvent($hStart, 'Start')
	EndIf
	GUICtrlSetState($hInp, $GUI_FOCUS)
EndFunc

Func Check()
	$msg = StringLeft(GUICtrlRead($hInp), 1)
	If StringRegExp($msg, '[a-z]', 0) Then
		$tWords &= $msg & ','
		GUICtrlSetData($hSel, $tWords)
		If StringInStr($Randomword, $msg) > 0 Then
			If StringInStr($tWords, $msg) = StringLen($tWords) - 1 Then
				For $i = 1 To StringLen($Randomword)
					$char = StringMid($Randomword, $i, 1)
					If $char = $msg Then
						$Emptyword = StringReplace($Emptyword, $i*2-1, $char, 1)
						GUICtrlSetData($hText, $Emptyword)
						PlaySound('ok.mp3', 0)
					EndIf
				Next
				If StringReplace($Emptyword, ' ', '') = $Randomword Then
					GUICtrlSetState($hStart, $GUI_ENABLE)
					Sleep(500)
					PlaySound('done.mp3', 0)
					GUICtrlSetState($hInp, $GUI_HIDE)
					$Score += 9 - $Error
					GUICtrlSetData($hScore, $Score)
					GUICtrlSetData($hWords, GUICtrlRead($hWords) + 1)
					$bNeu = False
					Start()
				EndIf
			Else
				PlaySound('double.mp3', 0)
				Galgen()
			EndIf
		Else
			If StringInStr($tWords, $msg) <> StringLen($tWords) - 1 Then
				PlaySound('double.mp3', 0)
			Else
				PlaySound('no.mp3', 0)
			EndIf
			Galgen()
		EndIf
	EndIf
	GUICtrlSetState($hInp, $GUI_FOCUS)
	GUICtrlSetData($hInp, '')
EndFunc

Func Galgen()
	$Error += 1
	GUICtrlSetData($hSc, 9-$Error)
	GUICtrlSetImage($hGalgen, @ScriptDir & '\gfx\galgen' & StringRight('0' & $Error, 2) & '.jpg')
	If $Error = 9 Then
		GUICtrlSetState($hInp, $GUI_HIDE)
		Sleep(500)
		PlaySound('enforce.mp3', 0)
		For $i = 1 To StringLen($Randomword)
			$Emptyword = StringReplace($Emptyword, $i*2-1, StringMid($Randomword, $i, 1), 1)
		Next
		GUICtrlSetData($hText, $Emptyword)
		For $i = 1 To 15
			If $Score > $aRanking[$i][1] Then
				Sleep(1650)
				PlaySound('hiscore.mp3', 0)
				Local $Name = InputBox('Neuer HiScore', 'Bitte Namen eingeben!', '', '', 200, 120)
				If $i < 15 Then
					For $j = 14 To $i Step -1
						$aRanking[$j+1][0] = $aRanking[$j][0]
						$aRanking[$j+1][1] = $aRanking[$j][1]
					Next
				EndIf
				$aRanking[$i][0] = $Name
				$aRanking[$i][1] = $Score
				RankingDisplay()
				ExitLoop
			EndIf
		Next
		GUICtrlSetImage($hStart, @ScriptDir & '\gfx\start.jpg')
		GUICtrlSetOnEvent($hStart, 'Start')
	EndIf
EndFunc
